
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Tenant_locationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const tenant_locations = await db.tenant_locations.create(
            {
                id: data.id || undefined,
        
        location_name: data.location_name
        ||
        null
            ,
            
        address: data.address
        ||
        null
            ,
            
        latitude: data.latitude
        ||
        null
            ,
            
        longitude: data.longitude
        ||
        null
            ,
            
        timezone: data.timezone
        ||
        null
            ,
            
        is_primary: data.is_primary
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await tenant_locations.setTenant( data.tenant || null, {
            transaction,
        });
        
        await tenant_locations.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return tenant_locations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const tenant_locationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                location_name: item.location_name
            ||
            null
            ,
            
                address: item.address
            ||
            null
            ,
            
                latitude: item.latitude
            ||
            null
            ,
            
                longitude: item.longitude
            ||
            null
            ,
            
                timezone: item.timezone
            ||
            null
            ,
            
                is_primary: item.is_primary
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const tenant_locations = await db.tenant_locations.bulkCreate(tenant_locationsData, { transaction });

        // For each item created, replace relation files
        

        return tenant_locations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const tenant_locations = await db.tenant_locations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.location_name !== undefined) updatePayload.location_name = data.location_name;
        
        
        if (data.address !== undefined) updatePayload.address = data.address;
        
        
        if (data.latitude !== undefined) updatePayload.latitude = data.latitude;
        
        
        if (data.longitude !== undefined) updatePayload.longitude = data.longitude;
        
        
        if (data.timezone !== undefined) updatePayload.timezone = data.timezone;
        
        
        if (data.is_primary !== undefined) updatePayload.is_primary = data.is_primary;
        
        
        updatePayload.updatedById = currentUser.id;

        await tenant_locations.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await tenant_locations.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await tenant_locations.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return tenant_locations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const tenant_locations = await db.tenant_locations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of tenant_locations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of tenant_locations) {
                await record.destroy({transaction});
            }
        });


        return tenant_locations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const tenant_locations = await db.tenant_locations.findByPk(id, options);

        await tenant_locations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await tenant_locations.destroy({
            transaction
        });

        return tenant_locations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const tenant_locations = await db.tenant_locations.findOne(
            { where },
            { transaction },
        );

        if (!tenant_locations) {
            return tenant_locations;
        }

        const output = tenant_locations.get({plain: true});

        
        
        
        
        
        
        
        
        output.ponds_location = await tenant_locations.getPonds_location({
            transaction
        });
        
        
        
        
        
        output.inventory_items_location = await tenant_locations.getInventory_items_location({
            transaction
        });
        
        
        
        
        
        
        
        output.marketplace_listings_fulfillment_location = await tenant_locations.getMarketplace_listings_fulfillment_location({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await tenant_locations.getTenant({
            transaction
        });
        
        
        output.organizations = await tenant_locations.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              tenant_name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.location_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tenant_locations',
                        'location_name',
                        filter.location_name,
                    ),
                };
            }
            
            if (filter.address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tenant_locations',
                        'address',
                        filter.address,
                    ),
                };
            }
            
            if (filter.timezone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tenant_locations',
                        'timezone',
                        filter.timezone,
                    ),
                };
            }
            

            
            

            
            if (filter.latitudeRange) {
                const [start, end] = filter.latitudeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    latitude: {
                    ...where.latitude,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    latitude: {
                    ...where.latitude,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.longitudeRange) {
                const [start, end] = filter.longitudeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    longitude: {
                    ...where.longitude,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    longitude: {
                    ...where.longitude,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_primary) {
                where = {
                    ...where,
                is_primary: filter.is_primary,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.tenant_locations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'tenant_locations',
                        'location_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.tenant_locations.findAll({
            attributes: [ 'id', 'location_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['location_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.location_name,
        }));
    }

    
};

